package ast;
public class FOR extends STATEMENT {
   public String idx;                // Input Attribute
   public EXPRESSION from;           // Child
   public EXPRESSION to;             // Child
   public EXPRESSION by;             // Child
   public STATS stats;               // Child
   public sym.Label forLabel;        // Synthesized
   public sym.Label endLabel;        // Synthesized
   public sym.Label incrLabel;       // Synthesized
   public sym.VariableSy tempTo;            // Synthesized. To store the temporary to value.
   public sym.Value byValue;                // Synthesized. To store the constant by-value.
   public sym.Symbol symbol;                // Synthesized         


    public FOR (String idx, EXPRESSION from, EXPRESSION to, EXPRESSION by, STATS stats, int position) {
       super(position);
       this.idx = idx;
       this.from = from;
       this.to = to;
       this.by = by;
       this.stats = stats;
   }

   public String toString(int indent) {
       String s = blanks(indent) + 
                  "<FOR " + 
                  "idx=\"" + idx + "\" " +
                  "pos=\"" + position + "\">\n";
       s += from.toString(indent+1);
       s += to.toString(indent+1);
       s += by.toString(indent+1);
       s += stats.toString(indent+1);
       s += blanks(indent) + "</FOR>\n";
       return s;
   }
}


